package wahlchaos;

import java.util.Vector;

import wahlchaos.stoerungen.StimmenStoerung;
import wahlchaos.stoerungen.StoerungEinzelkreis;
import wahlchaos.stoerungen.StoerungNull;
import wahlchaos.verteilungen.HareNiemeyer;
import wahlchaos.verteilungen.VerteilungsVerfahren;

public class Sim2 {
	//private final static String dateiname = "wahlchaos/btw05.csv";
	private static String dateiname;
	
	private static Bundestagswahl neueInstanz() {
		Bundestagswahl b = new Bundestagswahl(598);
		try {
			b.importData(dateiname);
		} catch(Exception e) {
			e.printStackTrace();
		}
		return b;
	}
	
	public static void main(String[] args) {		
		if (args.length<1) {
			System.exit(0);
		}
		dateiname = args[0];
		
		VerteilungsVerfahren v = new HareNiemeyer();
		Bundestagswahl referenz = neueInstanz();
		referenz.mergeData(new StoerungNull(referenz.getWahlkreisZahl(),referenz.getParteienZahl()));
		referenz.bestimmeSitzverteilung(v);
		//referenz.bestimmeSitzverteilung(new SainteLague());
		
		Bundestagswahl temp = neueInstanz();
		
		
		for (int k=0; k<referenz.getWahlkreisZahl(); k++) {
			StringBuffer kreisBuffer = new StringBuffer();
		//for (int k=298; k<referenz.getWahlkreisZahl(); k++) {
			int CDU = Bundestagswahl.CDU;
			if (k>=214 && k<=257) CDU = Bundestagswahl.CSU; 
			//for (int k=167; k<168; k++) {
			int minDiff = 0, maxDiff = 0;
			int minDiffStimmen = 10000;
			int maxDiffStimmen = 0;
			Vector<Integer> minDiffVector = null, maxDiffVector = null;
			for (int diff = -5000; diff <= 5000; diff+=500) {
				int[] diffArray = new int[3];
				diffArray[CDU] = diff;
				StimmenStoerung s = new StoerungEinzelkreis(temp.getWahlkreisZahl(),temp.getParteienZahl(),temp.getErststimmenOrginal(),temp.getZweitstimmenOrginal(),k,diffArray,null);
				temp.mergeData(s);
				temp.bestimmeSitzverteilung(v);
				
				int dummy = referenz.dist(temp);
				if (dummy>0) {
					if (Math.abs(diff) < Math.abs(minDiffStimmen)) {
						minDiffVector = referenz.diff2(temp);
						minDiffStimmen = diff;
						minDiff = dummy;
						maxDiff = dummy;
					}
					if (dummy>maxDiff) {
						maxDiffVector = referenz.diff2(temp);
						maxDiff = dummy;
						maxDiffStimmen = Math.abs(diff);
					}
				}
			}
			
			kreisBuffer.append("Kreis " + (k+1) + "\n");
			
			boolean print = false;
			
			if (minDiffVector != null) {
				kreisBuffer.append("Erststimmen: " + "\n");
				kreisBuffer.append("minimale Stimmen:" + "\n");
				kreisBuffer.append("CDU minus SPD: " + minDiffStimmen + " --> dSPD = " + minDiffVector.get(0) + " dCDU = " + minDiffVector.get(1) + "\n");
				if (maxDiffVector != null) {
					kreisBuffer.append("maximale Abweichung:");
					kreisBuffer.append("CDU minus SPD: " + maxDiffStimmen + " --> dSPD = " + maxDiffVector.get(0) + " dCDU = " + maxDiffVector.get(1) + "\n");
				}
				print = true;
			}

			maxDiff = 0; minDiff = 0;
			minDiffStimmen = 10000;
			maxDiffStimmen = 0;
			minDiffVector = null;
			maxDiffVector = null;
			int minCDU=0, minSPD=0, maxCDU=0, maxSPD=0;
			for (int diffSPD = -5000; diffSPD <= 5000; diffSPD+=500) {
				for (int diffCDU = -5000; diffCDU <= 5000; diffCDU+=500) {
					int[] diffArray = new int[3];
					diffArray[Bundestagswahl.SPD] = diffSPD;
					diffArray[CDU] = diffCDU;
					StimmenStoerung s = new StoerungEinzelkreis(temp.getWahlkreisZahl(),temp.getParteienZahl(),temp.getErststimmenOrginal(),temp.getZweitstimmenOrginal(),k,null,diffArray);
					temp.mergeData(s);
					temp.bestimmeSitzverteilung(v);
					
					int dummy = referenz.dist(temp);
					if (dummy>0) {
						if (Math.abs(diffCDU-diffSPD) < minDiffStimmen) {
							minDiffVector = referenz.diff2(temp);
							minDiffStimmen = Math.abs(diffCDU-diffSPD);
							minDiff = dummy;
							minCDU = diffCDU;
							minSPD = diffSPD;
							maxDiff = dummy;
						}
						if (dummy>maxDiff) {
							maxDiffVector = referenz.diff2(temp);
							maxDiff = dummy;
							maxCDU = diffCDU;
							maxSPD = diffSPD;
							maxDiffStimmen = Math.abs(diffCDU-diffSPD);
						}
					}
				}
			}
			
			if (minDiffVector != null) {
				kreisBuffer.append("Zweitstimmen:" + "\n");
				kreisBuffer.append("minimale Stimmen:" + "\n");
				kreisBuffer.append("CDU: " + minCDU + " SPD: " + minSPD + " --> dSPD = " + minDiffVector.get(0) + " dCDU = " + minDiffVector.get(1) + "\n");
				if (maxDiffVector != null) {
					kreisBuffer.append("maximale Abweichung:" + "\n");
					kreisBuffer.append("CDU: " + maxCDU + " SPD: " + maxSPD + " --> dSPD = " + maxDiffVector.get(0) + " dCDU = " + maxDiffVector.get(1) + "\n");
				}
				print = true;
			}
			
			if (print) {
				System.out.println(kreisBuffer.toString());
				System.out.println("---------------------------------------------");
			}

		}

	}

}

