package wahlchaos;

import java.io.IOException;

import wahlchaos.stoerungen.StimmenStoerung;
import wahlchaos.stoerungen.StoerungEinzelkreis;
import wahlchaos.stoerungen.StoerungNull;
import wahlchaos.verteilungen.HareNiemeyer;
import wahlchaos.verteilungen.VerteilungsVerfahren;

public class Sim3 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		Bundestagswahl bw = null, referenz = null;
		VerteilungsVerfahren v = new HareNiemeyer();
		
		int wahlkreise = 299;
		int maxLauf = 30;
		double maxStoer = 0.03;
		String file = "wahlchaos/btw05.csv";
		int[] totalDiffs = new int[wahlkreise];
		referenz = new Bundestagswahl(wahlkreise * 2);
		referenz.importData(file);
		referenz.mergeData(new StoerungNull(referenz.getWahlkreisZahl(), referenz.getParteienZahl()));
		referenz.bestimmeSitzverteilung(v);
		
		for (int kreis = 0; kreis < wahlkreise; ++kreis) {
			double avgBeteiligungsDiff = 0.0;
			for (int lauf = 0; lauf < maxLauf; ++lauf) {
				bw = new Bundestagswahl(wahlkreise * 2);
				bw.importData(file);
				int[] diff = bw.getErststimmenOrginal()[kreis].clone();
				int diffSum = 0;
				int total  = 0;
				for (int p=0; p<diff.length; ++p) {
					double factor = 2 * maxStoer * (Math.random() - 0.5);
					total += diff[p];
					diff[p] = (int) (factor * diff[p]);
					diffSum += diff[p]; 
				}
				avgBeteiligungsDiff += Math.abs(diffSum / (double)(total * maxLauf));
				StimmenStoerung s = new StoerungEinzelkreis(bw.getWahlkreisZahl(),bw.getParteienZahl(),bw.getErststimmenOrginal(),bw.getZweitstimmenOrginal(),kreis,diff,null);
				bw.mergeData(s);
				bw.bestimmeSitzverteilung(v);
				
				totalDiffs[kreis] += bw.dist(referenz);
			}
			System.out.println((kreis+1) + "   " + totalDiffs[kreis] + "   " + avgBeteiligungsDiff);
		}
	}

}
