package wahlchaos;

import java.io.FileOutputStream;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;

import javax.swing.text.NumberFormatter;
import javax.xml.stream.FactoryConfigurationError;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

import com.sun.xml.internal.stream.XMLOutputFactoryImpl;

import wahlchaos.stoerungen.StimmenStoerung;
import wahlchaos.stoerungen.StoerungEinzelkreis;
import wahlchaos.stoerungen.StoerungNull;
import wahlchaos.verteilungen.HareNiemeyer;
import wahlchaos.verteilungen.VerteilungsVerfahren;

public class Sim4 {

	public static String[] partei = new String[] { "SPD", "CDU/CSU", "Gr�ne", "FDP", "Die Linke. / PDS" };
	public static Map<Integer, Integer> intZuPartei;
	
	public static NumberFormatter nf = new NumberFormatter(new DecimalFormat("00"));
	public static NumberFormatter nf2 = new NumberFormatter(new DecimalFormat("000"));
	/**
	 * @param args
	 * @throws FactoryConfigurationError 
	 * @throws Exception 
	 */
	public static void main(String[] args) throws FactoryConfigurationError, Exception {
		intZuPartei = new HashMap<Integer, Integer>();
		intZuPartei.put(0, 0);
		intZuPartei.put(1, 1);
		intZuPartei.put(2, 1);
		intZuPartei.put(3, 2);
		intZuPartei.put(4, 3);
		intZuPartei.put(5, 4);
		
		/**
		 * need for some Hack for changed wahlkreis
		 */
		boolean wahl2002 = false;
		
		String[] laender = new String[16];
		laender[0] = "01";
		laender[1] = "13";
		laender[2] = "02";
		laender[3] = "03";
		laender[4] = "04";
		laender[5] = "12";
		laender[6] = "15";
		laender[7] = "11";
		laender[8] = "05";
		laender[9] = "14";
		laender[10] = "06";
		laender[11] = "16";
		laender[12] = "07";
		laender[13] = "09";
		laender[14] = "08";
		laender[15] = "10";
		
		
		Bundestagswahl bw = null, referenz = null;
		VerteilungsVerfahren v = new HareNiemeyer();
		
		FileOutputStream fos = new FileOutputStream("dummy.xml");
		XMLStreamWriter xml = XMLOutputFactoryImpl.newInstance().createXMLStreamWriter(fos, "iso-8859-1");
		writeHeader(xml);
		
		xml.writeStartElement("G1");
		xml.writeAttribute("id", "data-B00");
		xml.writeAttribute("name", "Bundesgebiet");
		
		xml.writeStartElement("value");
		xml.writeAttribute("id", "mainValue");
		xml.writeCharacters("0.0");
		xml.writeEndElement();
		
		for (String s : partei) {
			xml.writeStartElement("value");
			xml.writeAttribute("id", s);
			xml.writeCharacters("0.0");
			xml.writeEndElement();
		}		
		xml.writeEndElement(); // end G1
				
		int wahlkreise = 299;
		int maxLauf = 1;
		double minStoer = 0.0001;
		double stepStoer = 0.001;
		double maxStoer = 0.5;
		String file = "wahlchaos/btw05.csv";
		int[] totalDiffs = new int[wahlkreise];
		referenz = new Bundestagswahl(wahlkreise * 2);
		referenz.importData(file);
		referenz.mergeData(new StoerungNull(referenz.getWahlkreisZahl(), referenz.getParteienZahl()));
		referenz.bestimmeSitzverteilung(v);
		
		xml.writeStartElement("G2");
		xml.writeAttribute("id", "data-L01");
		xml.writeAttribute("name", Bundestagswahl.bundeslaenderNamen[0]);
	    //System.out.println(Bundestagswahl.bundeslaenderNamen[0]);
		xml.writeAttribute("link", "B00");
		
		xml.writeStartElement("value");
		xml.writeAttribute("id", "mainValue");
		xml.writeCharacters("0.0");
		xml.writeEndElement();
		
		for (String s : partei) {
			xml.writeStartElement("value");
			xml.writeAttribute("id", s);
			xml.writeCharacters("0.0");
			xml.writeEndElement();
		}		
		xml.writeEndElement(); // end G2
		
		int bundeslandCounter = 1;
		int kreisCounter = 0;
		for (int kreis = 0; kreis < wahlkreise; ++kreis) {
			++kreisCounter;
			
			if(wahl2002 && kreis == 196){
				kreis++;
			}
			if(wahl2002 && kreis == 217){
				xml.writeStartElement("G3");
				xml.writeAttribute("id", "data-k" + laender[bundeslandCounter-1] + nf2.valueToString(kreis));
				xml.writeAttribute("name", "Fuerstenbrueck");
				xml.writeAttribute("link", "L" + nf.valueToString(bundeslandCounter));
				
				xml.writeStartElement("value");
				xml.writeAttribute("id", "mainValue");
				xml.writeCharacters("50.0");
				xml.writeEndElement();
			}
			
			
			if (kreis == referenz.getBundeslaender()[bundeslandCounter-1]) {
				++bundeslandCounter;
				kreisCounter = 1;
				xml.writeStartElement("G2");
				xml.writeAttribute("id", "data-L" + laender[bundeslandCounter-1]);
				//System.out.println(Bundestagswahl.bundeslaenderNamen[bundeslandCounter-1]);
				xml.writeAttribute("name", laender[bundeslandCounter-1]);
				xml.writeAttribute("link", "B00");
				
				xml.writeStartElement("value");
				xml.writeAttribute("id", "mainValue");
				xml.writeCharacters("0.0");
				xml.writeEndElement();
				
				for (String s : partei) {
					xml.writeStartElement("value");
					xml.writeAttribute("id", s);
					xml.writeCharacters("0.0");
					xml.writeEndElement();
				}		
				xml.writeEndElement(); // end G2
			}
			
			/***********************************************************/
			
			double avgBeteiligungsDiff = 0.0;
			double steorung = 0;
			for (double Stoer = minStoer; Stoer < maxStoer; Stoer += stepStoer){
				boolean breakPoint = false;
				for (int lauf = 0; lauf < maxLauf; ++lauf) {
					bw = new Bundestagswahl(wahlkreise * 2);
					bw.importData(file);
					int[] diffErst = bw.getErststimmenOrginal()[kreis].clone();
					int[] diffZweit = bw.getZweitstimmenOrginal()[kreis].clone();
					int diffSum = 0;
					int total  = 0;
					for (int p=0; p<diffErst.length; ++p) {
						double factor = 2 * Stoer * (Math.random() - 0.5);
						total += diffErst[p];
						diffErst[p] = (int) (factor * diffErst[p]);
						diffZweit[p] = (int) (factor * diffZweit[p]);
						diffSum += diffErst[p]; 
					}
					avgBeteiligungsDiff += Math.abs(diffSum / (double)(total * maxLauf));
					StimmenStoerung s = new StoerungEinzelkreis(bw.getWahlkreisZahl(),bw.getParteienZahl(),bw.getErststimmenOrginal(),bw.getZweitstimmenOrginal(),kreis,diffErst,diffZweit);
					bw.mergeData(s);
					bw.bestimmeSitzverteilung(v);
					int delta = bw.dist(referenz);
					if(delta>0){
						//System.out.println((kreis+1) + " bei " + Stoer + "% (" + (lauf+1) +")");
						steorung = Stoer;
						totalDiffs[kreis] += delta;
						breakPoint = true;
						break;
					}
					
					totalDiffs[kreis] += delta;
				}
				if(breakPoint){
					break;
				}
			}
			if(steorung == 0){
				steorung = maxStoer;
			}
			/********************************************************************/
			
			xml.writeStartElement("G3");
			
			if(wahl2002 && kreis > 196 && kreis < 217){
				xml.writeAttribute("id", "data-k" + laender[bundeslandCounter-1] + nf2.valueToString(kreis));
				xml.writeAttribute("name", referenz.getWahlkreise()[kreis-1].replace('ä','a').replace('ö','o').replace('ü','u').replace('ß','s'));
			}else{
				xml.writeAttribute("id", "data-k" + laender[bundeslandCounter-1] + nf2.valueToString(kreis+1));
				xml.writeAttribute("name", referenz.getWahlkreise()[kreis].replace('ä','a').replace('ö','o').replace('ü','u').replace('ß','s'));
			}
			
			
			xml.writeAttribute("link", "L" + nf.valueToString(bundeslandCounter));
			
			xml.writeStartElement("value");
			xml.writeAttribute("id", "mainValue");
			System.out.println((kreis+1) + ": " +((double)Math.round(steorung * 10000)/100));
			xml.writeCharacters(""+((double)Math.round(steorung * 10000)/100));
			xml.writeEndElement();
			
			for (String s : partei) {
				xml.writeStartElement("value");
				xml.writeAttribute("id", s);
				xml.writeCharacters(new NumberFormatter(new DecimalFormat("0.00")).valueToString(Math.random() * 100.0).replace(',', '.'));
				xml.writeEndElement();
			}		
			xml.writeEndElement(); // end G3
			
			
			//System.out.println((kreis+1) + "   " + totalDiffs[kreis] + "   " + avgBeteiligungsDiff);
		}
		
		
		xml.writeEndDocument();
		
		xml.close();

	}
	
	public static void writeHeader(XMLStreamWriter xml) throws Exception {
		xml.writeStartDocument("iso-8859-1", "1.0");
		xml.writeStartElement("daten");
		xml.writeAttribute("id", "Statistik");
		xml.writeAttribute("kategorie", "Bundestagswahl 2005");
		xml.writeAttribute("erhebung", "Manipulationsanfaelligkeit");
		xml.writeAttribute("einheit", "in Prozentpunkten");
		xml.writeAttribute("berichtszeitraum", "2005");
		
		xml.writeStartElement("redaktionelles");
		xml.writeAttribute("id", "redaktionelles");
		xml.writeAttribute("anzahlKlassen", "5");
		xml.writeAttribute("farbschema", "11");
		xml.writeAttribute("classMethod", "vorgabe");
		
		xml.writeStartElement("theshold");
		xml.writeCharacters("0.05");
		xml.writeEndElement();
		xml.writeStartElement("theshold");
		xml.writeCharacters("0.15");
		xml.writeEndElement();
		xml.writeStartElement("theshold");
		xml.writeCharacters("0.50");
		xml.writeEndElement();
		xml.writeStartElement("theshold");
		xml.writeCharacters("2.00");
		xml.writeEndElement();
		
		xml.writeEndElement(); // end redaktionelles
		
		xml.writeEmptyElement("detailinfos");
		xml.writeAttribute("id", "detailinfos");
		xml.writeAttribute("erhebung", "Zweitstimmenanteil");
		xml.writeAttribute("berichtszeitraum", "2005");
		xml.writeAttribute("einheit", "in Prozent");
		xml.writeAttribute("detailTyp", "bar");
		//xml.writeEndElement(); // end detailinfos
		
		xml.writeStartElement("fussnote");
		xml.writeAttribute("id", "fussnote");
		xml.writeCharacters("bla");
		xml.writeEndElement();
	}

}
