package wahlchaos.stoerungen;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import wahlchaos.Bundestagswahl;

public class XMLParser extends DefaultHandler{
	
	private XMLStoerung stoerung;
	
	private int Wahlkreis;

	public XMLParser(XMLStoerung get) {
		super();
		this.stoerung = get;
		this.Wahlkreis = -1;
		// TODO Auto-generated constructor stub
	}


	    //===========================================================
	    // SAX DocumentHandler methods
	    //===========================================================

	    public void startDocument()
	    throws SAXException
	    {
	       
	    }

	    public void endDocument()
	    throws SAXException
	    {
	            

	    }


	    public void startElement( String namespaceURI, String localName,
	    		  String qName, Attributes atts ) throws SAXException
	    		{
  		  			if(qName == "name")
  		  			{
  		  				//System.out.println("Name: "+atts.getValue("value"));
  		  				this.stoerung.name = atts.getValue("value");
  		  			}
  		  			if(qName =="delta")
  		  			{
  		  				//System.out.println("Partei: "+atts.getValue("partei"));
  		  				//System.out.println("Zweitstimme: "+atts.getValue("type")+" "+atts.getValue("zweitstimme"));
  		  				if(this.Wahlkreis != -1)
  		  				{
  		  					int parteinummer = -1;
  		  					if(atts.getValue("partei").equals("SPD"))
  		  						 parteinummer = Bundestagswahl.SPD;
  		  					else if(atts.getValue("partei").equals("CDU"))
  		  						 parteinummer = Bundestagswahl.CDU;
  		  					else if(atts.getValue("partei").equals("CSU"))
  		  						 parteinummer = Bundestagswahl.CSU;
  		  					else if(atts.getValue("partei").equals("GRUENE"))
  		  						 parteinummer = Bundestagswahl.GRUENE;
  		  					else if(atts.getValue("partei").equals("FDP"))
  		  						 parteinummer = Bundestagswahl.FDP;
  		  					else if(atts.getValue("partei").equals("PDS"))
  		  						 parteinummer = Bundestagswahl.PDS;
  		  					else 
  		  						 new Exception("Ungueltiges Partei");
  		  					  		  					
  		  					if(atts.getValue("zweitstimme") != null)
  		  					{
  		  						if(atts.getValue("type").equals("plus"))
  		  							this.stoerung.zweitstimmenStoer[this.Wahlkreis][parteinummer]+=Integer.parseInt(atts.getValue("zweitstimme"));
  		  						else if(atts.getValue("type").equals("prozent"))
  		  							this.stoerung.zweitstimmenStoer[this.Wahlkreis][parteinummer]=(int)(this.stoerung.zweitstimmenOrginal[this.Wahlkreis][parteinummer]*(Integer.parseInt(atts.getValue("zweitstimme"))/100.0));
  		  						else new Exception("kein 'typ' gesetzt");
  		  					}
  		  					else if(atts.getValue("erststimme") != null)
  		  					{
  		  						if(atts.getValue("type").equals("plus"))
		  							this.stoerung.erststimmenStoer[this.Wahlkreis][parteinummer]+=Integer.parseInt(atts.getValue("erststimme"));
		  						else if(atts.getValue("type").equals("prozent"))
		  							this.stoerung.erststimmenStoer[this.Wahlkreis][parteinummer]=(int)(this.stoerung.erststimmenOrginal[this.Wahlkreis][parteinummer]*(Integer.parseInt(atts.getValue("erststimme"))/100.0));
		  						else new Exception("kein 'typ' gesetzt");
  		  					}
  		  					else new Exception("keine Stoerung gefunden");
  		  					
  		  				}
  		  				else
  		  				{
  		  					new Exception("Ungueltiges Format");
  		  				}
  		  			}
  		  				
  		  			if(qName == "kreis")
  		  			{
  		  				this.Wahlkreis = Integer.parseInt(atts.getValue("nummer"));
  		  				//System.out.println("Kreis: "+atts.getValue("nummer"));
  		  			}
	    		}
	    
	    public void endElement(String namespaceURI,
	                           String sName, // simple name
	                           String qName  // qualified name
	                          )
	    throws SAXException
	    {
	    	if(qName == "kreis")
	  			{
	    		this.Wahlkreis = -1;
	  			}
	    }

	    public void characters(char buf[], int offset, int len)
	    throws SAXException
	    {
	    }


}
