package wahlchaos.verteilungen;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;

class ParteiDivisor {
	public int index;
	public double div;
	
	public ParteiDivisor(int i, double d) {
		this.index = i;
		this.div = d;
	}
}

class ParteiDivisorComp implements Comparator<ParteiDivisor> {

	public int compare(ParteiDivisor o1, ParteiDivisor o2) {
		return (int)(o2.div-o1.div);
	}
	
}


public abstract class DivisorVerfahren extends VerteilungsVerfahren {
	protected LinkedList<Double> divisors;
	
	@Override
	public int[] berechneSitze() {
		int[] mandateSicher = new int[stimmen.length];
		LinkedList<ParteiDivisor> divisorListe = new LinkedList<ParteiDivisor>();
		ParteiDivisorComp comp = new ParteiDivisorComp();
		for(int i=0;i<stimmen.length;i++) {
			for (double div : divisors) {
				divisorListe.add(new ParteiDivisor(i,stimmen[i]/div));
			}
		}
		Collections.sort(divisorListe,comp);
		for (int i=0;i<mandate;i++) {
			++mandateSicher[divisorListe.get(i).index];
		}
		return mandateSicher;
	}
}
